package com.dali.galery.reflection.viewcategory

import com.dali.galery.reflection.inflate.data.InflateResult
import com.dali.galery.reflection.interceptor.Interceptor
import com.dali.galery.reflection.interceptor.Interceptor.Chain

internal class FallbackViewCreationInterceptor : Interceptor {

    override fun intercept(chain: Chain): InflateResult {
        val request = chain.request()
        val viewCreator = request.fallbackViewCreator
        val fallbackView = viewCreator.onCreateView(request.parent, request.name, request.context, request.attrs)

        return InflateResult(
            view = fallbackView,
            name = fallbackView?.javaClass?.name ?: request.name,
            context = request.context,
            attrs = request.attrs
        )
    }
}
